#all other necessary imports occur in levcreator
from levcreatorRewind import *
import inputbox


class Tweaker:
    def __init__(self,screen):
        self.painttweaks = {}
        self.tweaks      = {}
        self.bgstate     = {}
        self.current     = {}
        
        self.specials    = {}
        self.specials["push"]  = {}
        self.specials["burn"]  = {}
        self.specials["break"] = {}
        self.specials["door"]  = {} ##

        self.enemy       = []
        self.boss        = []
        self.screen = screen
        self.enemypal = 0
        self.bosspal  = 0

        #variables added in new version
        self.state      = "TWEAK"
        self.nextstate  = None
        self.target     = (None,None)
        self.x,self.y   = None,None
        self.tweakReady = False
        self.enemyReady = False
        self.bossReady  = False

        self.accessed = False #this will be set to true if not run as main
        self.savechange = True

    def tweak_init(self):
        self.tweakstart = pygame.Surface((1500,700)).convert_alpha()
        self.tweakstart.fill((0,0,0),(0,0,500,700))
        self.tweakstart.blit(tweaktiles,(50,0))
        if self.accessed == True: 
            self.tweakstart.blit(graphic["altoptions2"],(50,650))
        self.tweakstart.fill((255,0,0),(0,0,5,700))
        self.tweakstart.fill((255,0,0),(495,0,5,700))
        self.screen.blit(self.tweakstart,(0,0),(0,0,500,700))
        self.tweakReady = True
        
    def tweakcells(self):
        if not self.tweakReady:
                self.tweak_init()
                
        for click in pygame.event.get():
                    if click.type == pygame.MOUSEBUTTONDOWN:
                        hit = pygame.mouse.get_pressed()
                        if hit[0]:
                            self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                            #select square from pallet
                            if 100 <= self.target[0] < 350 and 100 <= self.target[1] < 200:
                                    self.x, self.y = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                    self.tweak_init()
                                    pygame.draw.rect(self.screen,(255,0,0),(self.x-1,self.y-1,52,52),2)
                            #declare square on grid
                            elif 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                                    d1,d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                    try:
                                            self.painttweaks[(d1,d2)] = ("tiles",None,(self.x-50,self.y,50,50))
                                            self.savechange = False
                                            if   (self.x,self.y) == (100,100): #declare solid
                                                self.tweaks[(d1,d2)] = 1
                                            elif (self.x,self.y) == (150,100): #declare water
                                                self.tweaks[(d1,d2)] = 0
                                            elif (self.x,self.y) == (200,100): #declare as foreground
                                                self.tweaks[(d1,d2)] = "fore"
                                            elif (self.x,self.y) == (200,150): #declare as foreground
                                                self.tweaks[(d1,d2)] = "solidfore"
                                            elif (self.x,self.y) == (250,100): #declare as hazard (cactus etc)
                                                self.tweaks[(d1,d2)] = "hazard"
                                            elif (self.x,self.y) == (300,100): #declare a portal
                                                now = self.screen.copy()
                                                newinput = inputbox.Inputer(screen1,"Enter mapset name")
                                                mapset = inputbox.main(newinput)

                                                newinput = inputbox.Inputer(screen1,"Enter starting map choords")
                                                start_mapchoords = inputbox.main(newinput)
                                                start_mapchoords = start_mapchoords.split(",")
                                                for i,num in enumerate(start_mapchoords):
                                                    start_mapchoords[i] = int(num)                                            

                                                newinput = inputbox.Inputer(screen1,"Enter players starting position")
                                                player_start = inputbox.main(newinput)
                                                player_start = player_start.split(",")
                                                for i,num in enumerate(player_start):
                                                    player_start[i] = int(num) 
                                                self.tweaks[(d1,d2)] = ("portal",mapset,start_mapchoords,player_start)
                                                self.screen.blit(now,(0,0))

                                            if (self.x,self.y) == (150,300): #declare a pushable block
                                                now = self.screen.copy()
                                                newinput   = inputbox.Inputer(screen1,"Enter possible push directions (NESW in binary)")
                                                directions = inputbox.main(newinput)
                                                newinput   = inputbox.Inputer(screen1,"Enter event_key or press enter to leave blank:")
                                                event_key  = inputbox.main(newinput)
                                                self.specials["push"][(d1,d2)] = (directions,event_key)
                                                self.screen.blit(now,(0,0))

                                            elif (self.x,self.y) == (250,300): #declare a door (that can be opened via an event)
                                                now = self.screen.copy()
                                                newinput = inputbox.Inputer(screen1,"Enter event type to que opening")
                                                event_type = inputbox.main(newinput)
                                                if "door" not in self.specials: self.specials["door"] = {}
                                                self.specials["door"][(d1,d2)] = event_type
                                                                                              
                                    except (UnboundLocalError,TypeError): print("select something you idiot")  ##added type error here
                                    paintit(self.screen,self.painttweaks)

                            #select special tag square from pallet
                            elif 100 <= self.target[0] < 350 and 300 <= self.target[1] < 350:
                                    self.x, self.y = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                    self.tweak_init()
                                    pygame.draw.rect(self.screen,(255,0,0),(self.x-1,self.y-1,52,52),2)
                            
                            #change to enemy placement mode
                            elif 100 <= self.target[0] <= 250 and 400 <= self.target[1] <= 450:
                                self.state = "ENEMY"
                                self.tweakReady = False

                            #delete all tweaks
                            elif 100 <= self.target[0] <= 250 and 520 <= self.target[1] <= 570:
                                self.tweaks = {}
                                self.painttweaks = {}
                                self.enemy = []
                                self.savechange = False
                                paintback(self.screen,self.bgstate)
                                paintfromdict(self.screen,self.current)
                                   
                            #Load a map or switch back to map edit mode if running in world map generator
                            elif 370 <= self.target[0]<= 450 and 650 <= self.target[1] <= 700:
                                    if not self.accessed:
                                        self.load_map()
                                    else:
                                        if self.savechange == False:
                                            self.state =     "SAVE"
                                            self.nextstate = "EDITMAP"
                                        else:
                                            self.state      = "EDITMAP"
                                            self.tweakReady = False
                                            self.enemyReady = False
                                            self.bossReady  = False

                            #if running from world map switch map to world editor
                            elif 250 <= self.target[0]<= 330 and 650 <= self.target[1] <= 700:
                                    if self.accessed:
                                        if self.savechange == False:
                                            self.state     = "SAVE"
                                            self.nextstate = "WORLD"
                                        else:
                                            self.state       = "WORLD"
                                            self.tweakReady = False
                                            self.enemyReady = False
                                            self.bossReady  = False

                            #saving a map with tweaks
                            elif 50 <= self.target[0] <= 130 and 650 <= self.target[1] <= 700:
                                    self.save()
                                    
                        #right clicking deletes the cell            
                        elif hit[2]:
                            self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                            d1, d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                            if ((d1,d2)) in self.tweaks and 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                                    self.tweaks.pop((d1,d2))
                                    self.painttweaks.pop((d1,d2))
                                    self.savechange = False
                                    paintback(self.screen,self.bgstate)
                                    paintfromdict(self.screen,self.current)
                                    paintit(self.screen,self.painttweaks)
                            for spectype in self.specials:
                                if ((d1,d2)) in self.specials[spectype]:
                                    self.specials[spectype].pop((d1,d2))
                                    self.savechange = False
                                    
                    if click.type == QUIT: self.state = "QUIT"

    def loadpallet(self):
                if self.enemypal < len(enemyplace): self.enemypal    += 1
                elif self.enemypal == len(enemyplace): self.enemypal  = 1
                self.screen.fill((0,0,0),(0,0,500,700))
                self.screen.blit(enemyplace[self.enemypal],(50,0))
                self.screen.fill((255,0,0),(0,0,5,700))
                self.screen.fill((255,0,0),(495,0,5,700))
                
    def loadbosspallet(self):
                if self.bosspal < len(bossplace): self.bosspal    += 1
                elif self.bosspal == len(bossplace): self.bosspal  = 1
                self.screen.fill((0,0,0),(0,0,500,700))
                self.screen.blit(bossplace[self.bosspal],(50,0))
                self.screen.fill((255,0,0),(0,0,5,700))
                self.screen.fill((255,0,0),(495,0,5,700))

    def load_map(self,file="ask"):
                try:
                    if file == "ask":
                        loaddata = pickle.load(open(askopenfilename(),'rb'))
                    else:
                        loaddata = pickle.load(open(file,'rb'))
                    self.bgstate = loaddata["background"]
                    self.current = loaddata["main"]
                    try:
                        self.tweaks      = loaddata["tweaks"]
                        self.painttweaks = loaddata["paintmaskdetails"]
                        self.enemy       = loaddata["enemies"]
                        if "boss" in loaddata:
                            self.boss    = loaddata["boss"]
                        else: self.boss  = []
                        
                    except:
                        self.tweaks      = {}
                        self.painttweaks = {}
                        self.enemy       = []
                    try:
                        self.specials = loaddata["specials"]
                    except: pass
                    paintback(self.screen,self.bgstate)
                    paintfromdict(self.screen,self.current)
                    if self.painttweaks:
                        paintit(self.screen,self.painttweaks)
                except (IOError,TypeError): pass

    def enemyedit(self):
        if not self.enemyReady:
            self.loadpallet()
            self.enemyReady = True

        for click in pygame.event.get():
            if click.type == pygame.MOUSEBUTTONDOWN:
                hit = pygame.mouse.get_pressed()
                if hit[0]:
                    self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                    #select enemy from pallet
                    if 100 <= self.target[0] < 400 and 50 <= self.target[1] < 650:
                        self.x, self.y = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                        self.screen.fill((0,0,0),(5,0,490,700))
                        self.screen.blit(enemyplace[self.enemypal],(50,0))
                        pygame.draw.rect(self.screen,(255,0,0),(self.x-1,self.y-1,52,52),2)

                    #paint selected enemy on the screen
                    elif 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                        d1,d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                        try:
                            speed   = int(self.x / 50)-2
                            monster = int(self.y / 50) 
                            self.painttweaks[(d1,d2)] = ("enemy",self.enemypal,(0,self.y,50,50))
                            self.enemy.append((monster+12*(self.enemypal-1),speed,(int((d1-500)/50),int(d2/50))))
                            self.savechange = False
                        except UnboundLocalError:
                            print("select something you idiot")
                        paintit(self.screen,self.painttweaks)
                        
                    # return to tweak editor
                    elif 50 <= self.target[0] <= 130 and 650 <= self.target[1] <= 700:
                        self.state = "TWEAK"
                        self.enemyReady = False
                        self.enemypal -= 1

                    #change to boss placement mode
                    elif 200 <= self.target[0] <= 280 and 650 <= self.target[1] <= 700:
                        self.state = "BOSS"
                        self.enemyReady = False
                        self.enemypal -= 1

                    # change pallet
                    elif 350 <= self.target[0] <= 450 and 650 <= self.target[1] <= 700:
                        self.loadpallet()
                        
                #right clicking deletes the cell            
                elif hit[2]:
                    self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                    d1, d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                    if 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                            for fiend in self.enemy:
                                if ((fiend[2][0]*50+500),(fiend[2][1]*50)) == (d1,d2):
                                    self.enemy.remove(fiend)
                                    self.painttweaks.pop((d1,d2))
                                    self.savechange = False
                            paintback(self.screen,self.bgstate)
                            paintfromdict(self.screen,self.current)
                            paintit(self.screen,self.painttweaks)

            if click.type == QUIT: self.state = "QUIT"


    def bossedit(self):
        if not self.bossReady:
            self.loadbosspallet()
            self.bossReady = True
            
        for click in pygame.event.get():
            if click.type == pygame.MOUSEBUTTONDOWN:
                hit = pygame.mouse.get_pressed()
                if hit[0]:
                    self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                    #select enemy from pallet
                    if 50 <= self.target[0] < 100 and 50 <= self.target[1] < 650:
                        self.x, self.y = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                        self.screen.fill((0,0,0),(5,0,490,700))
                        self.screen.blit(bossplace[self.bosspal],(50,0))
                        pygame.draw.rect(self.screen,(255,0,0),(self.x-1,self.y-1,52,52),2)

                    #paint selected enemy on the screen
                    elif 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                        d1,d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                        try:
                            speed   = int(self.x / 50)-2
                            monster = int(self.y / 50) 
                            self.painttweaks[(d1,d2)] = ("boss",self.bosspal,(0,self.y,50,50))
                            self.boss.append((monster+12*(self.bosspal-1),speed,(int((d1-500)/50),int(d2/50))))
                            self.savechange = False
                        except UnboundLocalError:
                            print("select something you idiot")
                        paintit(self.screen,self.painttweaks)
                        
                    # return to enemy editor
                    elif 50 <= self.target[0] <= 130 and 650 <= self.target[1] <= 700:
                        self.state = "ENEMY"
                        self.bossReady = False
                        self.bosspal -= 1

                    # change pallet
                    elif 350 <= self.target[0] <= 450 and 650 <= self.target[1] <= 700:
                        self.loadbosspallet()
                        
                #right clicking deletes the cell            
                elif hit[2]:
                    self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                    d1, d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                    if 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                            for fiend in self.boss:
                                if ((fiend[2][0]*50+500),(fiend[2][1]*50)) == (d1,d2):
                                    self.boss.remove(fiend)
                                    self.savechange = False
                                    self.painttweaks.pop((d1,d2))
                            paintback(self.screen,self.bgstate)
                            paintfromdict(self.screen,self.current)
                            paintit(self.screen,self.painttweaks)

            if click.type == QUIT: self.state = "QUIT"

    def save(self):
        mapdata = {}
        mapdata["background"]       = self.bgstate
        mapdata["main"]             = self.current
        mapdata["tweaks"]           = self.tweaks
        mapdata["paintmaskdetails"] = self.painttweaks
        mapdata["enemies"]          = self.enemy
        mapdata["specials"]         = self.specials
        mapdata["boss"]             = self.boss 
    
        try:
            filename = open(asksaveasfilename(),'wb')
            pickle.dump(mapdata,filename)
            filename.close()
            self.savechange = True
        except IOError:
            if self.nextstate != None:
                self.nextstate = None
                self.state = "TWEAK"
                paintback(self.screen,self.bgstate)
                paintfromdict(self.screen,self.current)
                paintit(self.screen,self.painttweaks)
        
    def update(self):
        if   self.state == "TWEAK":
            self.tweakcells()
        elif self.state == "ENEMY":
            self.enemyedit()
        elif self.state == "BOSS":
            self.bossedit()
        elif self.state == "QUIT":
            pygame.quit();Tk().quit();sys.exit()

        elif self.state == "SAVE":
            self.savequery()

    def savequery(self):
        self.screen.blit(graphic["savequery"],(750,200))
        for click in pygame.event.get():
                if click.type == pygame.MOUSEBUTTONDOWN:
                    hit = pygame.mouse.get_pressed()
                    if hit[0]:
                        self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])

                        if (750+50) <= self.target[0] <= (750+150) and (200+140) <= self.target[1] <= (200+175):
                            self.save()
                            if self.savechange == True:
                                self.state     = self.nextstate
                                self.nextstate = None
                                self.tweakReady = False
                                self.enemyReady = False
                                self.bossReady  = False
                        elif (750+200) <= self.target[0] <= (750+300) and (200+140) <= self.target[1] <= (200+175):
                            self.savechange = True
                            self.state      = self.nextstate
                            self.nextstate  = None
                            self.tweakReady = False
                            self.enemyReady = False
                            self.bossReady  = False
                        elif (750+350) <= self.target[0] <= (750+450) and (200+140) <= self.target[1] <= (200+175):
                            self.nextstate = None
                            self.state = "TWEAK"
                            paintback(self.screen,self.bgstate)
                            paintfromdict(self.screen,self.current)
                            paintit(self.screen,self.painttweaks)
    
def paintit(screen,paintthis):
        for key in paintthis:
            if paintthis[key][0] == "tiles":
                screen.blit(tweaktiles,key,paintthis[key][-1])
            if paintthis[key][0] == "enemy":
                screen.blit(enemyplace[paintthis[key][1]],key,paintthis[key][-1])
            if paintthis[key][0] == "boss":
                screen.blit(bossplace[paintthis[key][1]],key,paintthis[key][-1])
            
                        
######################

if __name__ == "__main__":
        myTweak = Tweaker(realscreen)
        while 1:
            myTweak.update()
            shrinkscreen = pygame.transform.scale(myTweak.screen,(size))
            screen1.blit(shrinkscreen,(0,0))
            pygame.display.update()


